! compile: ifort -free -o decompositionTest decompositionTest.f

program decompositonTest

implicit none
integer ne, np, numLongBlocks, numShortBlocks, longBlockSize, shortBlockSize
integer myNumLongBlks, myNumShortBlks, myrank, mystart, myend, myBlockSize

!ne = 11
!np =3 

print *, "Enter the number of elements and procs to simulate"
read (*,*) ne, np

! the size of the longer blocks
longBlockSize = ceiling(float(ne)/float(np))
shortBlockSize = floor(float(ne)/float(np))

! compute the number of blocks of each type
numLongBlocks = mod (ne,np)
numShortBlocks = np - numLongBlocks

!print *, numLongBlocks, longBlockSize, numShortBlocks, shortBlockSize

do myrank = 0, np-1
      myNumLongBlks = min(numLongBlocks, myrank+1)
      myNumShortBlks = myrank + 1 - myNumLongBlks
      myend = myNumLongBlks*longBlockSize + myNumShortBlks*shortBlockSize 
      if (myrank .lt. numLongBlocks) then
         myBlockSize = longBlockSize 
      else
         myBlockSize = shortBlockSize
      endif
      mystart = myend - myBlockSize + 1
      print *, myrank, mystart, myend, myend-mystart+1
enddo


end
